var blameUtils = {};
blameUtils.svn = require('./svn.js');
//todo git etc
function getFullBlame(data, lines) {
	var result = [], i, authors, linesNum, _lines;
	i = 1;
	if(lines) {
		linesNum = lines.length;
		for(i = 0; i < linesNum; i++){
			result.push({
				line: lines[i].toString(),
				author: this.getAuthor(data, lines[i])
			});
		}
	} else {
		while(this.getAuthor(data, i)){
			result.push({
				line: i.toString(),
				author: this.getAuthor(data, i)
			});
			i++;
		}
	}
	return result;
}
var credentials = {
	username: "",
	password: "",
	cwd: ""
};

function setCredentials (obj) {
	var prop;
	for (prop in obj){
		credentials[prop] = obj[prop];
	}
}
function Blamer (VCStype) {
	function TypedBlamer() {};
	if(blameUtils[VCStype]){
		TypedBlamer.prototype.parser = {};
		TypedBlamer.prototype.parser.getFullBlame = getFullBlame;
		TypedBlamer.prototype.parser.getAllAuthors = blameUtils[VCStype].getAllAuthors;
		TypedBlamer.prototype.parser.getLines = blameUtils[VCStype].getLines;
		TypedBlamer.prototype.parser.getAuthor = blameUtils[VCStype].getAuthor;
		TypedBlamer.prototype.blame = blameUtils[VCStype].blame.bind(null, credentials);
		TypedBlamer.prototype.setCredentials = setCredentials;
	}
	return new TypedBlamer();
}

module.exports =  Blamer;